/* 
 * File:   joystick.h
 * Author: jun
 *
 * Created on 2016/07/27, 21:17
 */

//#define Enable_PS

#ifndef JOYSTICK_H
#define	JOYSTICK_H

#include <stdint.h>
#include <system.h>

#ifdef	__cplusplus
extern "C" {
#endif

/** TYPE DEFINITIONS ************************************************/
typedef union _INTPUT_CONTROLS_TYPEDEF
{
    struct
    {
        struct
        {
            uint8_t button01_square:1;
            uint8_t button02_x:1;
            uint8_t button03_o:1;
            uint8_t button04_triangle:1;
            uint8_t button05_L1:1;
            uint8_t button06_R1:1;
            uint8_t button07_L2:1;
            uint8_t button08_R2:1;//
            uint8_t button09_select:1;
            uint8_t button10_start:1;
            uint8_t button11_left_stick:1;
            uint8_t button12_right_stick:1;
            uint8_t button13_home:1;
            uint8_t :3;    //filler
        } buttons;
        struct
        {
            uint8_t hat_switch:4;
            uint8_t :4;//filler
        } hat_switch;
        struct
        {
            uint8_t X;
            uint8_t Y;
            uint8_t Z;
            uint8_t Rz;
        } analog_stick;
        struct
        {
            uint8_t d00;
            uint8_t d01;
            uint8_t d02;
            uint8_t d03;
            uint8_t d04;
            uint8_t d05;
            uint8_t d06;
            uint8_t d07;
            uint8_t d08;
            uint8_t d09;
            uint8_t d10;
            uint8_t d11;
        } filler;
    } members;
    //uint8_t val[7];
    uint8_t val[19];
} INPUT_CONTROLS;


#if defined(FIXED_ADDRESS_MEMORY)
    #if defined(COMPILER_MPLAB_C18)
        #pragma udata JOYSTICK_DATA=JOYSTICK_DATA_ADDRESS
            extern INPUT_CONTROLS joystick_input;
        #pragma udata
    #elif defined(__XC8)
        extern INPUT_CONTROLS joystick_input @ JOYSTICK_DATA_ADDRESS;
    #endif
#else
    extern INPUT_CONTROLS joystick_input;
#endif

#define BTNBIT_01	0x00000001
#define BTNBIT_02	0x00000002
#define BTNBIT_03	0x00000004
#define BTNBIT_04       0x00000008
#define BTNBIT_05	0x00000010
#define BTNBIT_06	0x00000020
#define BTNBIT_07	0x00000040
#define BTNBIT_08	0x00000080
#define BTNBIT_09	0x00000100
#define BTNBIT_10	0x00000200
#define BTNBIT_11	0x00000400
#define BTNBIT_12	0x00000800
#define BTNBIT_13	0x00001000

#define DEVTYPE_UNKNOWN     0
#define DEVTYPE_FAMICOM     1
#define DEVTYPE_MD          2
#define DEVTYPE_SS          3
#define DEVTYPE_KABUTOGANI  4
#define DEVTYPE_PS          5


#define WAIT_PORTSET        Delay100TCYx(150)
#define IN_SEL_ANALOG_HAT   PORTCbits.RC7
#define IN_RAPPIDSET        PORTBbits.RB4





extern bool G_USBINT;

bool ReadFightingPad6B (char *devType, int *buttons);
bool ReadSS              (char *devType, int *buttons);
bool ReadFamicomJoycard(char *devType, int *buttons);
bool ReadKabutogani    (char *devType, int *buttons);
bool ReadPS              (char *devType, int *buttons);

void Set_AnalogAndHatValue
    (char right, char left, char up, char down);

unsigned char Get_HatSwitchVal
    (char right, char left, char up, char down);

#ifdef	__cplusplus
}
#endif

#endif	/* JOYSTICK_H */

